;
(function ($) {
    $.extend(FR.Report.Plugin.Fit, {

        extendPara: function (para, contentPane) {
            var isIE8 = FR.Browser.isIE8Before();
            var documentHeight = isIE8 ? $(window.document).height() : $(window).height();
            if (documentHeight === 0) {
                return;
            }
            var toolBar = $('.x-toolbar');
            var sheetToolBar = $('.fr-tabpane-controlbuttons');
            var extraHeight = 0;
            for (var i = 0; i < toolBar.length; i++) {
                extraHeight += $(toolBar[i]).height();
            }
            //直接取height，sougou高速模式还是有滚动条，额外加1px
            for (var i = 0; i < sheetToolBar.length; i++) {
                extraHeight += $(sheetToolBar[i]).height() + 1;
            }
            extraHeight += $('.parameter-container').height();

            documentHeight -= extraHeight;
            $.extend(para, {
                __webpage__: true,
                _paperWidth: isIE8 ? $(window.document).width() : $(window).width(),
                _paperHeight: documentHeight,
                __fit__: contentPane.__fit__
            });
        }
    });

    if(FR.Form) {
        FR.Form.getFitConfigFromServer = function (contenConfig) {
            if (contenConfig.__FIT__) {
                var sessionID = contenConfig.widgetUrl.getQuery('sessionID');
                var isIE8 = FR.Browser.isIE8Before();
                FR.ajax({
                    url: FR.servletURL,
                    data: {
                        op: 'fr_form',
                        cmd: 'fit_config',
                        sessionID: sessionID,
                        _: new Date().getTime(),
                        _PAPERWIDTH: isIE8 ? $(window.document).width() : $(window).width(),
                        _PAPERHEIGHT: isIE8 ? $(window.document).height() : $(window).height(),
                        _SHOWPARA: $('.parameter-container-collapseimg-down').length === 0,
                        _SHOWPARATEMPLATE : $('[widgetName=paramsTemplate]').length !== 0
                    },
                    async: false,
                    complete: function (res, status) {
                        if (status == 'success') {
                            contenConfig = FR.jsonDecode(res.responseText);
                        }
                    }
                });
            }

            return contenConfig;
        };
        FR.Form.bindFitResize = function (form, noBindResize) {
            if (noBindResize) {
                return;
            }
            $(window).load(function () {
                form.oriWidth = FR.windowWidth;
                form.oriHeight = FR.windowHeight;

            });
            function resize(){
                var width = FR.windowWidth;
                var height = FR.windowHeight;
                if (form.oriWidth === width && form.oriHeight === height) {
                    return;
                }
                form.oriWidth = width;
                form.oriHeight = height;
                if(form.isFitInBrowser){
                    return;
                }
                form.loadContentPane(true);
            }
            $(window).resize(function () {
                //firefox 在fs那边切换tab就会触发resize,这边搞成根据实际宽高度判断
                if (FR.Browser.isIE()) {
                    //ie快速拖窗口边缘的时候，直接获取的宽高不对
                    setTimeout(function () {
                        resize();
                    }, 0);
                }else{
                    resize();
                }
            });
        };
    }
})(jQuery);